=== modified file 'include/my_handler.h'
--- include/my_handler.h	2008-07-06 07:56:50 +0000
+++ include/my_handler.h	2008-07-06 10:32:31 +0000
@@ -112,6 +112,9 @@
 extern HA_KEYSEG *ha_find_null(HA_KEYSEG *keyseg, uchar *a);
 extern void my_handler_error_register(void);
 extern void my_handler_error_unregister(void);
+extern int ha_key_cmp(HA_KEYSEG *keyseg, uchar *a,uchar *b,
+                      uint key_length,uint nextflag,uint *diff_length);
+
 /*
   Inside an in-memory data record, memory pointers to pieces of the
   record (like BLOBs) are stored in their native byte order and in

=== modified file 'mysys/Makefile.am'
--- mysys/Makefile.am	2008-07-06 09:00:43 +0000
+++ mysys/Makefile.am	2008-07-06 10:32:31 +0000
@@ -31,13 +31,13 @@
 # Trick to get things compiled like they are shared, but linked directly in.
 noinst_LTLIBRARIES = libmysyslt.la
 
-noinst_HEADERS =	mysys_priv.h my_static.h 
+noinst_HEADERS =	mysys_priv.h my_static.h my_handler_errors.h
 libmysyslt_la_SOURCES = my_init.c my_getwd.c mf_getdate.c \
 			mf_path.c mf_loadpath.c my_file.c \
 			my_open.c my_create.c my_dup.c my_seek.c my_read.c \
 			my_write.c my_getpagesize.c \
 			mf_iocache.c mf_iocache2.c mf_cache.c mf_tempfile.c \
-			mf_tempdir.c \
+			mf_tempdir.c my_handler.c \
 			my_malloc.c my_realloc.c my_once.c mulalloc.c \
 			my_alloc.c my_new.cc \
 			my_fopen.c my_fstream.c my_getsystime.c \

=== renamed file 'storage/myisam/my_handler.c' => 'mysys/my_handler.c'
--- storage/myisam/my_handler.c	2008-07-06 09:20:03 +0000
+++ mysys/my_handler.c	2008-07-06 10:32:31 +0000
@@ -21,7 +21,7 @@
 #include <my_handler.h>
 #include <my_sys.h>
 
-#include "myisamdef.h"
+#include "mysys_priv.h"
 #include "my_handler_errors.h"
 
 int ha_compare_text(CHARSET_INFO *charset_info, uchar *a, uint a_length,

=== renamed file 'storage/myisam/my_handler_errors.h' => 'mysys/my_handler_errors.h'
=== modified file 'sql/item.h'
--- sql/item.h	2008-07-05 23:05:08 +0000
+++ sql/item.h	2008-07-06 10:32:31 +0000
@@ -2540,6 +2540,5 @@
 
 extern Cached_item *new_Cached_item(THD *thd, Item *item,
                                     bool use_result_field);
-extern Item_result item_cmp_type(Item_result a,Item_result b);
 extern void resolve_const_item(THD *thd, Item **ref, Item *cmp_item);
 extern bool field_is_equal_to_item(Field *field,Item *item);

=== modified file 'sql/item_cmpfunc.h'
--- sql/item_cmpfunc.h	2008-06-25 05:29:13 +0000
+++ sql/item_cmpfunc.h	2008-07-06 10:32:31 +0000
@@ -363,7 +363,8 @@
   }
   Item *neg_transformer(THD *thd);
   virtual Item *negated_item();
-  bool subst_argument_checker(uchar **arg) { return TRUE; }
+  bool subst_argument_checker(uchar **arg __attribute__((__unused__)))
+  { return TRUE; }
 };
 
 class Item_func_not :public Item_bool_func
@@ -483,7 +484,7 @@
   enum Functype rev_functype() const { return EQUAL_FUNC; }
   cond_result eq_cmp_result() const { return COND_TRUE; }
   const char *func_name() const { return "<=>"; }
-  Item *neg_transformer(THD *thd) { return 0; }
+  Item *neg_transformer(THD *thd __attribute__((__unused__))) { return 0; }
 };
 
 
@@ -574,13 +575,14 @@
 public:
   inline void negate() { negated= !negated; }
   inline void top_level_item() { pred_level= 1; }
-  Item *neg_transformer(THD *thd)
+  Item *neg_transformer(THD *thd __attribute__((__unused__)))
   {
     negated= !negated;
     return this;
   }
   bool eq(const Item *item, bool binary_cmp) const;
-  bool subst_argument_checker(uchar **arg) { return TRUE; }
+  bool subst_argument_checker(uchar **arg __attribute__((__unused__)))
+  { return TRUE; }
 };
 
 
@@ -781,7 +783,8 @@
         item  Constant item to store value into. The item must be of the same
               type that create_item() returns.
   */
-  virtual void value_to_item(uint pos, Item *item) { }
+  virtual void value_to_item(uint pos __attribute__((__unused__)),
+                             Item *item __attribute__((__unused__))) { }
   
   /* Compare values number pos1 and pos2 for equality */
   bool compare_elems(uint pos1, uint pos2)
@@ -932,7 +935,8 @@
   virtual int compare(cmp_item *item)= 0;
   static cmp_item* get_comparator(Item_result type, CHARSET_INFO *cs);
   virtual cmp_item *make_same()= 0;
-  virtual void store_value_by_template(cmp_item *tmpl, Item *item)
+  virtual void store_value_by_template(cmp_item *tmpl  __attribute__((__unused__)),
+                                       Item *item)
   {
     store_value(item);
   }
@@ -1081,7 +1085,7 @@
   {
     value_res= item->val_str(&value);
   }
-  int cmp(Item *item)
+  int cmp(Item *item __attribute__((__unused__)))
   {
     // Should never be called
     DBUG_ASSERT(0);
@@ -1434,7 +1438,8 @@
   void traverse_cond(Cond_traverser, void *arg, traverse_order order);
   void neg_arguments(THD *thd);
   enum_field_types field_type() const { return MYSQL_TYPE_LONGLONG; }
-  bool subst_argument_checker(uchar **arg) { return TRUE; }
+  bool subst_argument_checker(uchar **arg __attribute__((__unused__)))
+  { return TRUE; }
   Item *compile(Item_analyzer analyzer, uchar **arg_p,
                 Item_transformer transformer, uchar *arg_t);
 };

=== modified file 'sql/item_func.h'
--- sql/item_func.h	2008-06-25 05:29:13 +0000
+++ sql/item_func.h	2008-07-06 10:32:31 +0000
@@ -285,7 +285,8 @@
 
   void fix_num_length_and_dec();
   void find_num_type();
-  String *str_op(String *str) { DBUG_ASSERT(0); return 0; }
+  String *str_op(String *str __attribute__((__unused__)))
+  { DBUG_ASSERT(0); return 0; }
 };
 
 
@@ -302,7 +303,8 @@
   }
 
   void find_num_type();
-  String *str_op(String *str) { DBUG_ASSERT(0); return 0; }
+  String *str_op(String *str __attribute__((__unused__)))
+  { DBUG_ASSERT(0); return 0; }
 };
 
 
@@ -991,7 +993,8 @@
 {
 protected:
   udf_handler udf;
-  bool is_expensive_processor(uchar *arg) { return TRUE; }
+  bool is_expensive_processor(uchar *arg __attribute__((__unused__)))
+  { return TRUE; }
 
 public:
   Item_udf_func(udf_func *udf_arg)
@@ -1000,7 +1003,7 @@
     :Item_func(list), udf(udf_arg) {}
   const char *func_name() const { return udf.name(); }
   enum Functype functype() const   { return UDF_FUNC; }
-  bool fix_fields(THD *thd, Item **ref)
+  bool fix_fields(THD *thd, Item **ref __attribute__((__unused__)))
   {
     DBUG_ASSERT(fixed == 0);
     bool res= udf.fix_fields(thd, this, arg_count, args);

=== modified file 'sql/item_strfunc.h'
--- sql/item_strfunc.h	2008-06-25 05:29:13 +0000
+++ sql/item_strfunc.h	2008-07-06 10:32:31 +0000
@@ -396,7 +396,8 @@
   }
   const char *func_name() const { return "user"; }
   const char *fully_qualified_func_name() const { return "user()"; }
-  int save_in_field(Field *field, bool no_conversions)
+  int save_in_field(Field *field,
+                    bool no_conversions __attribute__((__unused__)))
   {
     return save_str_value_in_field(field, &str_value);
   }

=== modified file 'sql/item_sum.h'
--- sql/item_sum.h	2008-06-25 05:29:13 +0000
+++ sql/item_sum.h	2008-07-06 10:32:31 +0000
@@ -363,8 +363,8 @@
   */
   void no_rows_in_result() { clear(); }
 
-  virtual bool setup(THD *thd) {return 0;}
-  virtual void make_unique() {}
+  virtual bool setup(THD *thd __attribute__((__unused__))) {return 0;}
+  virtual void make_unique(void) {}
   Item *get_tmp_table_item(THD *thd);
   virtual Field *create_tmp_field(bool group, TABLE *table,
                                   uint convert_blob_length);
@@ -680,7 +680,7 @@
   String *val_str(String *str);
   void reset_field();
   void update_field();
-  Item *result_item(Field *field)
+  Item *result_item(Field *field __attribute__((__unused__)))
   { return new Item_avg_field(hybrid_type, this); }
   void no_rows_in_result() {}
   const char *func_name() const { return "avg("; }
@@ -771,7 +771,7 @@
   my_decimal *val_decimal(my_decimal *);
   void reset_field();
   void update_field();
-  Item *result_item(Field *field)
+  Item *result_item(Field *field __attribute__((__unused__)))
   { return new Item_variance_field(this); }
   void no_rows_in_result() {}
   const char *func_name() const
@@ -813,7 +813,7 @@
     {}
   enum Sumfunctype sum_func () const { return STD_FUNC; }
   double val_real();
-  Item *result_item(Field *field)
+  Item *result_item(Field *field __attribute__((__unused__)))
     { return new Item_std_field(this); }
   const char *func_name() const { return "std("; }
   Item *copy_or_same(THD* thd);

=== modified file 'sql/item_timefunc.h'
--- sql/item_timefunc.h	2008-06-25 05:29:13 +0000
+++ sql/item_timefunc.h	2008-07-06 10:32:31 +0000
@@ -355,7 +355,8 @@
     DBUG_ASSERT(fixed == 1);
     return  val_decimal_from_date(decimal_value);
   }
-  int save_in_field(Field *field, bool no_conversions)
+  int save_in_field(Field *field,
+                    bool no_conversions __attribute__((__unused__)))
   {
     return save_date_in_field(field);
   }
@@ -381,7 +382,8 @@
     DBUG_ASSERT(fixed == 1);
     return  val_decimal_from_date(decimal_value);
   }
-  int save_in_field(Field *field, bool no_conversions)
+  int save_in_field(Field *field,
+                    bool no_conversions __attribute__((__unused__)))
   {
     return save_date_in_field(field);
   }
@@ -411,7 +413,8 @@
     DBUG_ASSERT(fixed == 1);
     return  val_decimal_from_time(decimal_value);
   }
-  int save_in_field(Field *field, bool no_conversions)
+  int save_in_field(Field *field,
+                    bool no_conversions __attribute__((__unused__)))
   {
     return save_time_in_field(field);
   }
@@ -783,7 +786,8 @@
     DBUG_ASSERT(fixed == 1);
     return  val_decimal_from_date(decimal_value);
   }
-  int save_in_field(Field *field, bool no_conversions)
+  int save_in_field(Field *field,
+                    bool no_conversions __attribute__((__unused__)))
   {
     return save_date_in_field(field);
   }
@@ -811,7 +815,8 @@
     DBUG_ASSERT(fixed == 1);
     return  val_decimal_from_time(decimal_value);
   }
-  int save_in_field(Field *field, bool no_conversions)
+  int save_in_field(Field *field,
+                    bool no_conversions __attribute__((__unused__)))
   {
     return save_time_in_field(field);
   }
@@ -846,7 +851,8 @@
     DBUG_ASSERT(fixed == 1);
     return  val_decimal_from_date(decimal_value);
   }
-  int save_in_field(Field *field, bool no_conversions)
+  int save_in_field(Field *field,
+                    bool no_conversions __attribute__((__unused__)))
   {
     return save_date_in_field(field);
   }

=== modified file 'sql/log_event.h'
--- sql/log_event.h	2008-07-06 04:27:02 +0000
+++ sql/log_event.h	2008-07-06 10:32:31 +0000
@@ -951,7 +951,7 @@
             write_data_header(file) ||
             write_data_body(file));
   }
-  virtual bool write_data_header(IO_CACHE* file)
+  virtual bool write_data_header(IO_CACHE* file __attribute__((__unused__)))
   { return 0; }
   virtual bool write_data_body(IO_CACHE* file __attribute__((unused)))
   { return 0; }
@@ -1080,7 +1080,7 @@
     @retval 0     Event applied successfully
     @retval errno Error code if event application failed
   */
-  virtual int do_apply_event(Relay_log_info const *rli)
+  virtual int do_apply_event(Relay_log_info const *rli __attribute__((__unused__)))
   {
     return 0;                /* Default implementation does nothing */
   }
@@ -1583,7 +1583,8 @@
   Log_event_type get_type_code() { return QUERY_EVENT; }
 #ifndef MYSQL_CLIENT
   bool write(IO_CACHE* file);
-  virtual bool write_post_header_for_derived(IO_CACHE* file) { return FALSE; }
+  virtual bool write_post_header_for_derived(IO_CACHE* file __attribute__((__unused__)))
+  { return FALSE; }
 #endif
   bool is_valid() const { return query != 0; }
 
@@ -2372,7 +2373,8 @@
   uint charset_number;
   bool is_null;
 #ifndef MYSQL_CLIENT
-  User_var_log_event(THD* thd_arg, char *name_arg, uint name_len_arg,
+  User_var_log_event(THD* thd_arg __attribute__((__unused__)),
+                     char *name_arg, uint name_len_arg,
                      char *val_arg, ulong val_len_arg, Item_result type_arg,
 		     uint charset_number_arg)
     :Log_event(), name(name_arg), name_len(name_len_arg), val(val_arg),
@@ -2430,7 +2432,7 @@
 private:
 #if !defined(MYSQL_CLIENT) && defined(HAVE_REPLICATION)
   virtual int do_update_pos(Relay_log_info *rli);
-  virtual enum_skip_reason do_shall_skip(Relay_log_info *rli)
+  virtual enum_skip_reason do_shall_skip(Relay_log_info *rli __attribute__((__unused__)))
   {
     /*
       Events from ourself should be skipped, but they should not

=== modified file 'sql/opt_range.h'
--- sql/opt_range.h	2008-06-25 05:29:13 +0000
+++ sql/opt_range.h	2008-07-06 10:32:31 +0000
@@ -212,7 +212,7 @@
       0     Ok
       other Error
   */
-  virtual int init_ror_merged_scan(bool reuse_handler)
+  virtual int init_ror_merged_scan(bool reuse_handler __attribute__((__unused__)))
   { DBUG_ASSERT(0); return 1; }
 
   /*
@@ -234,7 +234,7 @@
     This function is implemented only by quick selects that merge other quick
     selects output and/or can produce output suitable for merging.
   */
-  virtual void add_info_string(String *str) {};
+  virtual void add_info_string(String *str __attribute__((__unused__))) {};
   /*
     Return 1 if any index used by this quick select
     uses field which is marked in passed bitmap.

=== modified file 'sql/set_var.h'
--- sql/set_var.h	2008-06-29 17:07:40 +0000
+++ sql/set_var.h	2008-07-06 10:32:31 +0000
@@ -95,15 +95,19 @@
       (binlog_status == SESSION_VARIABLE_IN_BINLOG);
   }
   virtual bool update(THD *thd, set_var *var)=0;
-  virtual void set_default(THD *thd_arg, enum_var_type type) {}
+  virtual void set_default(THD *thd_arg __attribute__((__unused__)),
+                           enum_var_type type __attribute__((__unused__)))
+  {}
   virtual SHOW_TYPE show_type() { return SHOW_UNDEF; }
-  virtual uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base)
+  virtual uchar *value_ptr(THD *thd __attribute__((__unused__)),
+                           enum_var_type type __attribute__((__unused__)),
+                           LEX_STRING *base __attribute__((__unused__)))
   { return 0; }
   virtual bool check_type(enum_var_type type)
   { return type != OPT_GLOBAL; }		/* Error if not GLOBAL */
   virtual bool check_update_type(Item_result type)
   { return type != INT_RESULT; }		/* Assume INT */
-  virtual bool check_default(enum_var_type type)
+  virtual bool check_default(enum_var_type type __attribute__((__unused__)))
   { return option_limits == 0; }
   Item *item(THD *thd, enum_var_type type, LEX_STRING *base);
   virtual bool is_struct() { return 0; }
@@ -159,7 +163,9 @@
   bool update(THD *thd, set_var *var);
   void set_default(THD *thd, enum_var_type type);
   SHOW_TYPE show_type() { return SHOW_LONG; }
-  uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base)
+  uchar *value_ptr(THD *thd __attribute__((__unused__)),
+                   enum_var_type type __attribute__((__unused__)),
+                   LEX_STRING *base __attribute__((__unused__)))
   { return (uchar*) value; }
 };
 
@@ -190,7 +196,9 @@
   bool update(THD *thd, set_var *var);
   void set_default(THD *thd, enum_var_type type);
   SHOW_TYPE show_type() { return SHOW_LONGLONG; }
-  uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base)
+  uchar *value_ptr(THD *thd __attribute__((__unused__)),
+                   enum_var_type type __attribute__((__unused__)),
+                   LEX_STRING *base __attribute__((__unused__)))
   { return (uchar*) value; }
 };
 
@@ -209,9 +217,12 @@
   bool update(THD *thd, set_var *var);
   void set_default(THD *thd, enum_var_type type);
   SHOW_TYPE show_type() { return SHOW_MY_BOOL; }
-  uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base)
+  uchar *value_ptr(THD *thd __attribute__((__unused__)),
+                   enum_var_type type __attribute__((__unused__)),
+                   LEX_STRING *base __attribute__((__unused__)))
   { return (uchar*) value; }
-  bool check_update_type(Item_result type) { return 0; }
+  bool check_update_type(Item_result type __attribute__((__unused__)))
+  { return 0; }
 };
 
 
@@ -252,13 +263,16 @@
     (*set_default_func)(thd, type);
   }
   SHOW_TYPE show_type() { return SHOW_CHAR; }
-  uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base)
+  uchar *value_ptr(THD *thd __attribute__((__unused__)),
+                   enum_var_type type __attribute__((__unused__)),
+                   LEX_STRING *base __attribute__((__unused__)))
   { return (uchar*) value; }
   bool check_update_type(Item_result type)
   {
     return type != STRING_RESULT;		/* Only accept strings */
   }
-  bool check_default(enum_var_type type) { return 0; }
+  bool check_default(enum_var_type type __attribute__((__unused__)))
+  { return 0; }
 };
 
 
@@ -274,24 +288,29 @@
   {
     value= new_value;
   }
-  bool check(THD *thd, set_var *var)
+  bool check(THD *thd __attribute__((__unused__)),
+             set_var *var __attribute__((__unused__)))
   {
     return 1;
   }
-  bool update(THD *thd, set_var *var)
+  bool update(THD *thd __attribute__((__unused__)),
+              set_var *var __attribute__((__unused__)))
   {
     return 1;
   }
   SHOW_TYPE show_type() { return SHOW_CHAR; }
-  uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base)
+  uchar *value_ptr(THD *thd __attribute__((__unused__)),
+                   enum_var_type type __attribute__((__unused__)),
+                   LEX_STRING *base __attribute__((__unused__)))
   {
     return (uchar*) value;
   }
-  bool check_update_type(Item_result type)
+  bool check_update_type(Item_result type __attribute__((__unused__)))
   {
     return 1;
   }
-  bool check_default(enum_var_type type) { return 1; }
+  bool check_default(enum_var_type type __attribute__((__unused__)))
+  { return 1; }
   bool is_readonly() const { return 1; }
 };
 
@@ -303,25 +322,30 @@
   sys_var_const_str_ptr(sys_var_chain *chain, const char *name_arg, char **value_arg)
     :sys_var(name_arg),value(value_arg)
   { chain_sys_var(chain); }
-  bool check(THD *thd, set_var *var)
+  bool check(THD *thd __attribute__((__unused__)),
+             set_var *var __attribute__((__unused__)))
   {
     return 1;
   }
-  bool update(THD *thd, set_var *var)
+  bool update(THD *thd __attribute__((__unused__)),
+              set_var *var __attribute__((__unused__)))
   {
     return 1;
   }
   SHOW_TYPE show_type() { return SHOW_CHAR; }
-  uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base)
+  uchar *value_ptr(THD *thd __attribute__((__unused__)),
+                   enum_var_type type __attribute__((__unused__)),
+                   LEX_STRING *base __attribute__((__unused__)))
   {
     return (uchar*) *value;
   }
-  bool check_update_type(Item_result type)
+  bool check_update_type(Item_result type __attribute__((__unused__)))
   {
     return 1;
   }
-  bool check_default(enum_var_type type) { return 1; }
-  bool is_readonly() const { return 1; }
+  bool check_default(enum_var_type type __attribute__((__unused__)))
+  { return 1; }
+  bool is_readonly(void) const { return 1; }
 };
 
 
@@ -341,7 +365,8 @@
   bool update(THD *thd, set_var *var);
   SHOW_TYPE show_type() { return SHOW_CHAR; }
   uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base);
-  bool check_update_type(Item_result type) { return 0; }
+  bool check_update_type(Item_result type __attribute__((__unused__)))
+  { return 0; }
 };
 
 
@@ -354,10 +379,15 @@
       TYPELIB *typelib, sys_after_update_func func)
     :sys_var(name_arg,func), offset(offset_arg), enum_names(typelib)
   { chain_sys_var(chain); }
-  bool check(THD *thd, set_var *var) { return 1; }
-  bool update(THD *thd, set_var *var) { return 1; }
+  bool check(THD *thd __attribute__((__unused__)),
+             set_var *var __attribute__((__unused__)))
+  { return 1; }
+  bool update(THD *thd __attribute__((__unused__)),
+              set_var *var __attribute__((__unused__)))
+  { return 1; }
   SHOW_TYPE show_type() { return SHOW_CHAR; }
-  bool check_update_type(Item_result type) { return 1; }
+  bool check_update_type(Item_result type __attribute__((__unused__)))
+  { return 1; }
   bool is_readonly() const { return 1; }
   uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base);
 };
@@ -371,7 +401,8 @@
               Binlog_status_enum binlog_status= NOT_IN_BINLOG)
     :sys_var(name_arg, func, binlog_status)
   {}
-  bool check_type(enum_var_type type) { return 0; }
+  bool check_type(enum_var_type type __attribute__((__unused__)))
+  { return 0; }
   bool check_default(enum_var_type type)
   {
     return type == OPT_GLOBAL && !option_limits;
@@ -470,7 +501,8 @@
   {
     return check_enum(thd, var, &bool_typelib);
   }
-  bool check_update_type(Item_result type) { return 0; }
+  bool check_update_type(Item_result type __attribute__((__unused__)))
+  { return 0; }
 };
 
 
@@ -499,7 +531,8 @@
   void set_default(THD *thd, enum_var_type type);
   SHOW_TYPE show_type() { return SHOW_CHAR; }
   uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base);
-  bool check_update_type(Item_result type) { return 0; }
+  bool check_update_type(Item_result type __attribute__((__unused__)))
+  { return 0; }
 };
 
 
@@ -558,7 +591,8 @@
   { chain_sys_var(chain); }
   bool check(THD *thd, set_var *var);
   bool update(THD *thd, set_var *var);
-  bool check_update_type(Item_result type) { return 0; }
+  bool check_update_type(Item_result type __attribute__((__unused__)))
+  { return 0; }
   bool check_type(enum_var_type type) { return type == OPT_GLOBAL; }
   SHOW_TYPE show_type() { return SHOW_MY_BOOL; }
   uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base);
@@ -573,7 +607,9 @@
   bool check_update_type(Item_result type) { return type != STRING_RESULT; }
   SHOW_TYPE show_type() { return SHOW_CHAR; }
   bool update(THD *thd, set_var *var);
-  void set_default(THD *thd, enum_var_type type) { DBUG_POP(); }
+  void set_default(THD *thd __attribute__((__unused__)),
+                   enum_var_type type __attribute__((__unused__)))
+  { DBUG_POP(); }
   uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *b);
 };
 
@@ -591,8 +627,9 @@
   bool update(THD *thd, set_var *var);
   void set_default(THD *thd, enum_var_type type);
   bool check_type(enum_var_type type)    { return type == OPT_GLOBAL; }
-  bool check_default(enum_var_type type) { return 0; }
-  SHOW_TYPE show_type() { return SHOW_LONG; }
+  bool check_default(enum_var_type type __attribute__((__unused__)))
+  { return 0; }
+  SHOW_TYPE show_type(void) { return SHOW_LONG; }
   uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base);
 };
 
@@ -662,7 +699,7 @@
   {
     return ((type != STRING_RESULT) && (type != INT_RESULT));
   }
-  bool check_default(enum_var_type type) { return 0; }
+  bool check_default(enum_var_type type __attribute__((__unused__))) { return 0; }
   virtual void set_default(THD *thd, enum_var_type type)= 0;
 };
 
@@ -686,7 +723,8 @@
   {
     return ((type != STRING_RESULT) && (type != INT_RESULT));
   }
-  bool check_default(enum_var_type type) { return 0; }
+  bool check_default(enum_var_type type __attribute__((__unused__)))
+  { return 0; }
   bool update(THD *thd, set_var *var);
   uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base);
   virtual void set_default(THD *thd, enum_var_type type)= 0;
@@ -767,7 +805,8 @@
     :sys_var(name_arg), offset(offset_arg)
   { chain_sys_var(chain); }
   uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base);
-  bool check_default(enum_var_type type) { return 1; }
+  bool check_default(enum_var_type type __attribute__((__unused__)))
+  { return 1; }
   bool is_struct() { return 1; }
 };
 
@@ -811,7 +850,8 @@
   {
     return type != STRING_RESULT;		/* Only accept strings */
   }
-  bool check_default(enum_var_type type) { return 0; }
+  bool check_default(enum_var_type type __attribute__((__unused__)))
+  { return 0; }
   bool check(THD *thd, set_var *var);
   bool update(THD *thd, set_var *var);
   void update2(THD *thd, enum_var_type type, DATE_TIME_FORMAT *new_value);
@@ -846,13 +886,15 @@
   {
     return check_set(thd, var, enum_names);
   }
-  virtual void set_default(THD *thd, enum_var_type type)
-  {  
+  virtual void set_default(THD *thd __attribute__((__unused__)),
+                           enum_var_type type __attribute__((__unused__)))
+  {
     *value= 0;
   }
   bool update(THD *thd, set_var *var);
   uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base);
-  bool check_update_type(Item_result type) { return 0; }
+  bool check_update_type(Item_result type __attribute__((__unused__)))
+  { return 0; }
   SHOW_TYPE show_type() { return SHOW_CHAR; }
 };
 
@@ -886,7 +928,8 @@
   }
   bool update(THD *thd, set_var *var);
   uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base);
-  bool check_update_type(Item_result type) { return 0; }
+  bool check_update_type(Item_result type __attribute__((__unused__)))
+  { return 0; }
   void set_default(THD *thd, enum_var_type type);
   SHOW_TYPE show_type() { return SHOW_CHAR; }
 };
@@ -906,16 +949,21 @@
     :sys_var(name_arg), var_type(type), 
        show_type_value(show_type_arg), value_ptr_func(value_ptr_func_arg)
   { chain_sys_var(chain); }
-  bool update(THD *thd, set_var *var) { return 1; }
-  bool check_default(enum_var_type type) { return 1; }
+  bool update(THD *thd __attribute__((__unused__)),
+              set_var *var __attribute__((__unused__)))
+  { return 1; }
+  bool check_default(enum_var_type type __attribute__((__unused__)))
+  { return 1; }
   bool check_type(enum_var_type type) { return type != var_type; }
-  bool check_update_type(Item_result type) { return 1; }
-  uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base)
+  bool check_update_type(Item_result type __attribute__((__unused__)))
+  { return 1; }
+  uchar *value_ptr(THD *thd, enum_var_type type __attribute__((__unused__)),
+                   LEX_STRING *base __attribute__((__unused__)))
   {
     return (*value_ptr_func)(thd);
   }
-  SHOW_TYPE show_type() { return show_type_value; }
-  bool is_readonly() const { return 1; }
+  SHOW_TYPE show_type(void) { return show_type_value; }
+  bool is_readonly(void) const { return 1; }
 };
 
 
@@ -927,14 +975,19 @@
   sys_var_have_option(sys_var_chain *chain, const char *variable_name):
     sys_var(variable_name)
   { chain_sys_var(chain); }
-  uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base)
+  uchar *value_ptr(THD *thd __attribute__((__unused__)),
+                   enum_var_type type __attribute__((__unused__)),
+                   LEX_STRING *base __attribute__((__unused__)))
   {
     return (uchar*) show_comp_option_name[get_option()];
   }
-  bool update(THD *thd, set_var *var) { return 1; }
-  bool check_default(enum_var_type type) { return 1; }
+  bool update(THD *thd __attribute__((__unused__)),
+              set_var *var __attribute__((__unused__))) { return 1; }
+  bool check_default(enum_var_type type __attribute__((__unused__)))
+  { return 1; }
   bool check_type(enum_var_type type) { return type != OPT_GLOBAL; }
-  bool check_update_type(Item_result type) { return 1; }
+  bool check_update_type(Item_result type __attribute__((__unused__)))
+  { return 1; }
   SHOW_TYPE show_type() { return SHOW_CHAR; }
   bool is_readonly() const { return 1; }
 };
@@ -989,7 +1042,8 @@
   {
     return type != STRING_RESULT;		/* Only accept strings */
   }
-  bool check_default(enum_var_type type) { return 0; }
+  bool check_default(enum_var_type type __attribute__((__unused__)))
+  { return 0; }
   bool update(THD *thd, set_var *var);
   uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base);
   virtual void set_default(THD *thd, enum_var_type type);
@@ -1022,7 +1076,8 @@
                        ulonglong SV::*offset_arg):
     sys_var_thd(name_arg), offset(offset_arg)
   { chain_sys_var(chain); }
-  bool check(THD *thd, set_var *var) {return 0;}
+  bool check(THD *thd __attribute__((__unused__)),
+             set_var *var __attribute__((__unused__))) {return 0;}
   bool update(THD *thd, set_var *var);
   void set_default(THD *thd, enum_var_type type);
   SHOW_TYPE show_type() { return SHOW_DOUBLE; }
@@ -1079,7 +1134,8 @@
   {
     return ((type != STRING_RESULT) && (type != INT_RESULT));
   }
-  bool check_default(enum_var_type type) { return 0; }
+  bool check_default(enum_var_type type __attribute__((__unused__)))
+  { return 0; }
   bool update(THD *thd, set_var *var);
   uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base);
   virtual void set_default(THD *thd, enum_var_type type);

=== modified file 'sql/sql_class.h'
--- sql/sql_class.h	2008-06-25 05:29:13 +0000
+++ sql/sql_class.h	2008-07-06 10:32:31 +0000
@@ -2068,7 +2068,8 @@
 public:
   select_result();
   virtual ~select_result() {};
-  virtual int prepare(List<Item> &list, SELECT_LEX_UNIT *u)
+  virtual int prepare(List<Item> &list __attribute__((__unused__)),
+                      SELECT_LEX_UNIT *u)
   {
     unit= u;
     return 0;
@@ -2083,7 +2084,8 @@
   { return fields.elements; }
   virtual bool send_fields(List<Item> &list, uint flags)=0;
   virtual bool send_data(List<Item> &items)=0;
-  virtual bool initialize_tables (JOIN *join=0) { return 0; }
+  virtual bool initialize_tables (JOIN  __attribute__((__unused__)) *join=0)
+  { return 0; }
   virtual void send_error(uint errcode,const char *err);
   virtual bool send_eof()=0;
   /**
@@ -2115,8 +2117,10 @@
 {
 public:
   select_result_interceptor() {}              /* Remove gcc warning */
-  uint field_count(List<Item> &fields) const { return 0; }
-  bool send_fields(List<Item> &fields, uint flag) { return FALSE; }
+  uint field_count(List<Item> &fields __attribute__((__unused__))) const
+  { return 0; }
+  bool send_fields(List<Item> &fields __attribute__((__unused__)),
+                   uint flag __attribute__((__unused__))) { return FALSE; }
 };
 
 
@@ -2653,6 +2657,5 @@
 
 void add_diff_to_status(STATUS_VAR *to_var, STATUS_VAR *from_var,
                         STATUS_VAR *dec_var);
-void mark_transaction_to_rollback(THD *thd, bool all);
 
 #endif /* MYSQL_SERVER */

=== modified file 'sql/sql_lex.h'
--- sql/sql_lex.h	2008-07-06 09:20:03 +0000
+++ sql/sql_lex.h	2008-07-06 10:32:31 +0000
@@ -366,8 +366,12 @@
   }
   static void *operator new(size_t size, MEM_ROOT *mem_root)
   { return (void*) alloc_root(mem_root, (uint) size); }
-  static void operator delete(void *ptr,size_t size) { TRASH(ptr, size); }
-  static void operator delete(void *ptr, MEM_ROOT *mem_root) {}
+  static void operator delete(void *ptr __attribute__((__unused__)),
+                              size_t size __attribute__((__unused__)))
+  { TRASH(ptr, size); }
+  static void operator delete(void *ptr __attribute__((__unused__)),
+                              MEM_ROOT *mem_root __attribute__((__unused__)))
+  {}
   st_select_lex_node(): linkage(UNSPECIFIED_TYPE) {}
   virtual ~st_select_lex_node() {}
   inline st_select_lex_node* get_master() { return master; }
@@ -390,12 +394,13 @@
   virtual List<Item>* get_item_list();
   virtual ulong get_table_join_options();
   virtual TABLE_LIST *add_table_to_list(THD *thd, Table_ident *table,
-					LEX_STRING *alias,
-					ulong table_options,
-					thr_lock_type flags= TL_UNLOCK,
-					List<Index_hint> *hints= 0,
+                                        LEX_STRING *alias,
+                                        ulong table_options,
+                                        thr_lock_type flags= TL_UNLOCK,
+                                        List<Index_hint> *hints= 0,
                                         LEX_STRING *option= 0);
-  virtual void set_lock_for_tables(thr_lock_type lock_type) {}
+  virtual void set_lock_for_tables(thr_lock_type lock_type __attribute__((__unused__)))
+  {}
 
   friend class st_select_lex_unit;
   friend bool mysql_new_select(struct st_lex *lex, bool move_down);
@@ -1677,9 +1682,11 @@
   {
     return (void*) alloc_root(mem_root, (uint) size);
   }
-  static void operator delete(void *ptr,size_t size)
+  static void operator delete(void *ptr __attribute__((__unused__)),
+                              size_t size __attribute__((__unused__)))
   { TRASH(ptr, size); }
-  static void operator delete(void *ptr, MEM_ROOT *mem_root)
+  static void operator delete(void *ptr __attribute__((__unused__)),
+                              MEM_ROOT *mem_root __attribute__((__unused__)))
   { /* Never called */ }
 };
 

=== modified file 'storage/heap/ha_heap.cc'
--- storage/heap/ha_heap.cc	2008-06-25 05:29:13 +0000
+++ storage/heap/ha_heap.cc	2008-07-06 10:32:31 +0000
@@ -28,7 +28,8 @@
                                     TABLE_SHARE *table, 
                                     MEM_ROOT *mem_root);
 
-int heap_panic(handlerton *hton, ha_panic_function flag)
+int heap_panic(handlerton *hton __attribute__((__unused__)),
+               ha_panic_function flag)
 {
   return hp_panic(flag);
 }
@@ -361,7 +362,7 @@
   return error;
 }
 
-void ha_heap::position(const uchar *record)
+void ha_heap::position(const uchar *record __attribute__((__unused__)))
 {
   *(HEAP_PTR*) ref= heap_position(file);	// Ref is aligned
 }
@@ -418,7 +419,8 @@
   return 0;
 }
 
-int ha_heap::external_lock(THD *thd, int lock_type)
+int ha_heap::external_lock(THD *thd __attribute__((__unused__)),
+                           int lock_type __attribute__((__unused__)))
 {
   return 0;					// No external locking
 }
@@ -531,9 +533,9 @@
   return heap_indexes_are_disabled(file);
 }
 
-THR_LOCK_DATA **ha_heap::store_lock(THD *thd,
-				    THR_LOCK_DATA **to,
-				    enum thr_lock_type lock_type)
+THR_LOCK_DATA **ha_heap::store_lock(THD *thd __attribute__((__unused__)),
+                                    THR_LOCK_DATA **to,
+                                    enum thr_lock_type lock_type)
 {
   if (lock_type != TL_IGNORE && file->lock.type == TL_UNLOCK)
     file->lock.type=lock_type;
@@ -553,7 +555,7 @@
 }
 
 
-void ha_heap::drop_table(const char *name)
+void ha_heap::drop_table(const char *name __attribute__((__unused__)))
 {
   file->s->delete_on_close= 1;
   close();
@@ -715,8 +717,9 @@
     create_info->auto_increment_value= stats.auto_increment_value;
 }
 
-void ha_heap::get_auto_increment(uint64_t offset, uint64_t increment,
-                                 uint64_t nb_desired_values,
+void ha_heap::get_auto_increment(uint64_t offset __attribute__((__unused__)),
+                                 uint64_t increment __attribute__((__unused__)),
+                                 uint64_t nb_desired_values __attribute__((__unused__)),
                                  uint64_t *first_value,
                                  uint64_t *nb_reserved_values)
 {

=== modified file 'storage/heap/ha_heap.h'
--- storage/heap/ha_heap.h	2008-07-05 17:02:05 +0000
+++ storage/heap/ha_heap.h	2008-07-06 10:32:31 +0000
@@ -55,7 +55,8 @@
             HA_REC_NOT_IN_SEQ | HA_CAN_INSERT_DELAYED | HA_NO_TRANSACTIONS |
             HA_HAS_RECORDS | HA_STATS_RECORDS_IS_EXACT);
   }
-  uint32_t index_flags(uint inx, uint part, bool all_parts) const
+  uint32_t index_flags(uint inx, uint part __attribute__((__unused__)),
+                       bool all_parts __attribute__((__unused__))) const
   {
     return ((table_share->key_info[inx].algorithm == HA_KEY_ALG_BTREE) ?
             HA_READ_NEXT | HA_READ_PREV | HA_READ_ORDER | HA_READ_RANGE :
@@ -66,7 +67,9 @@
   uint max_supported_key_part_length() const { return MAX_KEY_LENGTH; }
   double scan_time()
   { return (double) (stats.records+stats.deleted) / 20.0+10; }
-  double read_time(uint index, uint ranges, ha_rows rows)
+  double read_time(uint index __attribute__((__unused__)),
+                   uint ranges __attribute__((__unused__)),
+                   ha_rows rows)
   { return (double) rows /  20.0+1; }
 
   int open(const char *name, int mode, uint test_if_locked);

=== modified file 'storage/myisam/Makefile.am'
--- storage/myisam/Makefile.am	2008-07-06 09:00:43 +0000
+++ storage/myisam/Makefile.am	2008-07-06 10:32:31 +0000
@@ -53,7 +53,7 @@
 			$(d_dbug) \
 			$(top_builddir)/strings/libmystringslt.la -lz
 noinst_PROGRAMS =	mi_test1 mi_test2 mi_test3 #ft_test1 ft_eval
-noinst_HEADERS =	myisamdef.h my_handler_errors.h \
+noinst_HEADERS =	myisamdef.h  \
 			fulltext.h ftdefs.h ft_test1.h ft_eval.h \
 			ha_myisam.h mi_extrafunc.h
 mi_test1_DEPENDENCIES=	$(LIBRARIES)
@@ -84,7 +84,7 @@
 			mi_rrnd.c mi_scan.c mi_cache.c \
 			mi_statrec.c mi_packrec.c mi_dynrec.c \
 			mi_update.c mi_write.c mi_unique.c \
-			mi_delete.c my_handler.c \
+			mi_delete.c \
 			my_pread.c my_lock.c \
 			mf_keycache.c mf_keycaches.c \
 			mi_rprev.c mi_rfirst.c mi_rlast.c mi_rsame.c \

